#include <joyos.h>

#define ENCODER_RIGHT 24
#define ENCODER_LEFT 25
#define DISTSENSOR_RIGHT_FRONT  23
#define right_forward 1
# define left_forward 1
# define right_motor 0
# define left_motor 2
# define LSB_MS_PER_DEG	1320.0
# define gyro_port 11


uint16_t my_encoder_0[4];
uint16_t motor_vel[4]={150,150,150,150};
uint16_t encoder_read(uint8_t encoder_read);

void my_encoder_init() {
	my_encoder_0[0]=0;		
	my_encoder_0[1]=0;
	my_encoder_0[2]=0;
	my_encoder_0[3]=0;
}



uint16_t my_encoder_read(uint8_t encoder) {
	return encoder_read(encoder)-my_encoder_0[encoder-24];
}

void my_encoder_reset(uint8_t encoder) {
			my_encoder_0[encoder-24]=encoder_read(encoder);
}

void delta_motor_vel(uint16_t changes[4]){
	motor_vel[0]+=changes[0];
	motor_vel[1]+=changes[1];
	motor_vel[2]+=changes[2];
	motor_vel[3]+=changes[3];
	motor_set_vel(0,motor_vel[0]);
	motor_set_vel(1,motor_vel[1]);
	motor_set_vel(2,motor_vel[2]);
	motor_set_vel(3,motor_vel[3]);	
}


void hopefully_accurate_drive() {
//pause(250);

	
		pause(50);
		//motor 2 matched with encoder 25
		//motor 0 matched with encoder 24
		if (encoder_read(24) - encoder_read(25) > 5) { // if right wheel turns faster
			motor_set_vel(0,125*(encoder_read(25)/(encoder_read(24))));// slow down right motor speed proportionally
			motor_set_vel(2,125);// keep left motor speed the same
		} else if (encoder_read(24)-encoder_read(25) < -5) { // if left wheel turns faster
			motor_set_vel(0,125);// keep right motor speed the same
			motor_set_vel(2,125*(encoder_read(24)/(encoder_read(25))));// slow down left motor speed proportionally
		} else if ((encoder_read(24)-encoder_read(25) <= 5) && (encoder_read(24)-encoder_read(25) >= -5)) {
			motor_set_vel(0,125);
			motor_set_vel(2,125);
		}
		
		printf("\ne24=%03d e25=%03d",encoder_read(24),encoder_read(25));
		pause(50);
		
	
//		my_encoder_reset(24);
//		my_encoder_reset(25);
//	motor_set_vel(2,0); //when dist sensor sees values between 245-255 pause for 100 then continue to turn right method...
//	motor_set_vel(0,0);
//	pause(300);

}
/*
void accuratedrive_straight(float drive_time) {
	float enddrive_time, startdrive_time;
	hopefully_accurate_drive();
	pause(50);
	startdrive_time = get_time();
	do {
		enddrive_time = get_time();
	} while (enddrive_time - startdrive_time < drive_time); 
	
	motor_set_vel(right_motor, right_forward * 0);
	motor_set_vel(left_motor, left_forward * 0);
}


//turn left functions

void turn_right(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	printf( "\n%f" , (float) startdrive_angle);
	go_click();
	motor_set_vel(right_motor,-110);
	motor_set_vel(left_motor, 110);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle > drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}
*/

int usetup (void) {
//	my_encoder_init();
	set_auto_halt(0);
	printf_P (PSTR("\nPlace robot,    press go."));
	go_click ();
	printf_P (PSTR("\nStabilizing..."));
	pause (500);
	printf_P (PSTR("\nCalibrating     offset...\n"));
	gyro_init (gyro_port, LSB_MS_PER_DEG, 500L);
	return 0;
}

//Run

int umain (void) {
/*
	int i=0;
	
	for(i=0; i<4; i++) {
		accuratedrive_straight(3000);
		pause(500);
		turn_left(90.0);// stop turning when difference in degrees is 90
		pause(500);
	}
*/
	while(!(stop_press())){
		hopefully_accurate_drive();
	}
	return 0;
}