
#include <joyos.h>

#define DISTSENSOR_RIGHT_FRONT  23
uint16_t sensor_rf;
//printf("\nDistance = %d", analog_read());

void drive_straight() {
	
	while (analog_read(23) < 245) { //when dist sensor on right front sees values less than 245 aka is far away drive straight
		motor_set_vel(0,-120);  //sets velocity of right motor to value 100 in motor port 0 (right motor counterclockwise to go straight)
		motor_set_vel(1,125);  //sets velocity of left motor to value 100 in motor port 1 (left motor clockwise to go straight)
		pause(50);  
	}
	motor_set_vel(0,0); //when dist sensor sees values between 245-255 pause for 100 then continue to turn right method...
	motor_set_vel(1,0);
	pause(500);
}

#define GYRO_PORT_NUMBER 11
#define GYRO_PORT 		11
#define LSB_MS_PER_DEG	1062.0
uint16_t gyro;
	
void turn_right() {
	while (analog_read(11) < -90) { //gyroscope angle less than 90 degrees
		motor_set_vel(0,100);
		motor_set_vel(1,100);
		pause(50);
	}
	motor_set_vel (0,0);
	motor_set_vel (1,0);
	pause(500);

}

int usetup (void) {
	set_auto_halt(0);
	printf_P (PSTR("\nPlace robot,    press go."));
	go_click ();
	printf_P (PSTR("\nStabilizing..."));
	pause (500);
	printf_P (PSTR("\nCalibrating     offset...\n"));
	gyro_init (GYRO_PORT, LSB_MS_PER_DEG, 500L);
	return 0;
}

//Run
int umain (void) {
	analog_read(DISTSENSOR_RIGHT_FRONT);
	analog_read(GYRO_PORT_NUMBER);

	drive_straight();
	
	turn_right();
	return 0;
}
	
	
	
