#include <joyos.h>

#define RightMotor 0
#define LeftMotor 2
#define left_IR 15
#define mid_IR 14
#define right_IR 13
#define LSB_MS_PER_DEG	1330
#define gyro_port 11
#define right_forward 1
#define left_forward 1
#define right_motor 0
#define left_motor 2
#define rear_dist 21
#define front_dist 22
#define gateservo 2

uint16_t Corner;

//define turns


void wide_right(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,0);
	motor_set_vel(left_motor, 130);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle > drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void wide_left(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,130);
	motor_set_vel(left_motor, 0);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle < drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}



//back up until we either see a robot or the opponent's short wall
void timed_backup() {

	while (analog_read(rear_dist) < 300) {
		motor_set_vel(right_motor, right_forward * -115);
		motor_set_vel(left_motor, left_forward * -110);
	}
	
	pause(10);
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

//drive forward until we see either a robot or the opponent's long wall or the flagbox

void timed_drivestraight() {

	while (analog_read(front_dist) < 300) {
		motor_set_vel(right_motor, 115);
		motor_set_vel(left_motor, 110);
	}
}



//close gate
void close_gate() {
	servo_set_pos(gateservo, 0);
	pause(50);
}

void stop() {
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
	pause(50);
}

/*
void init_decision() {

	if (analog_read(22)<(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		drive_straight(10);
	} else if (analog_read(22)<(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		turn_left_two(85);
	} else if (analog_read(22)>(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(600);
		pause(10);
		turn_right_one(-83);
	} else if (analog_read(22)>(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(500);
		pause(10);
		turn_left_two(85);
		pause(10);
		turn_left_two(85);
	}
}

*/

/*int usetup (void) {
	set_auto_halt(0);
	
	printf_P (PSTR("\nPlace robot,    press go.")); 
	go_click ();
	printf_P (PSTR("\nStabilizing..."));
	pause (500);
	printf_P (PSTR("\nCalibrating     offset...\n"));
	gyro_init (gyro_port, LSB_MS_PER_DEG, 500L);
	go_click ();
//	do
//	{
//		printf("\nCorner: %d", Corner=frob_read_range(0,1));
//		pause(50);
//	} while (!go_press());
	
//	go_click();

	return(0);
}*/

/*int umain (void) {
	//init_decision();
	gyro_set_degrees(0);
	timed_backup();
	close_gate();
	wide_right(-90);
	wide_right(-90);
	drive_straight(1000);
	back_up(900);
	wide_left(80);
	timed_drivestraight();
	turn_right_one(90);
	drive_straight(500);
	stop();
	return 0;
}*/


