#include <joyos.h>

#define ENCODER_RIGHT 24
#define ENCODER_LEFT 25
#define DISTSENSOR_RIGHT_FRONT  23

uint16_t encoder_read(uint8_t encoder);

void hopefully_accurate_drive() {

	while (analog_read(23) < 245) { //when dist sensor on right front sees values less than 245 aka is far away drive straight
		if (encoder_read(24) - encoder_read(25) > 5) { // if right wheel turns faster
			motor_set_vel(0,125*(encoder_read(25)/(encoder_read(24))));// slow down right motor speed proportionally
			motor_set_vel(1,125);// keep left motor speed the same
		} else if (encoder_read(24)-encoder_read(25) < -5) { // if left wheel turns faster
			motor_set_vel(0,125);// keep right motor speed the same
			motor_set_vel(1,125*(encoder_read(24)/(encoder_read(25))));// slow down left motor speed proportionally
		} else if ((encoder_read(24)-encoder_read(25) <= 5) && (encoder_read(24)-encoder_read(25) >= -5)) {
			motor_set_vel(0,125);
			motor_set_vel(1,125);
		}
		pause(50);
	}
	motor_set_vel(0,0); //when dist sensor sees values between 245-255 pause for 100 then continue to turn right method...
	motor_set_vel(1,0);
	pause(100);
}

int usetup (void) {
	return 0;
}

//Run
int umain (void) {
	hopefully_accurate_drive();
	return 0;
}