#include <joyos.h>

#define RightMotor 0
#define LeftMotor 2
#define left_IR 15
#define mid_IR 14
#define right_IR 13
#define LSB_MS_PER_DEG	1330.0
#define gyro_port 11
#define right_forward 1
#define left_forward 1
#define right_motor 0
#define left_motor 2

uint16_t Corner;

//define turns

void back_up(int drive_time) {
	int enddrive_time, startdrive_time;
	
	motor_set_vel(right_motor, right_forward * -110);
	motor_set_vel(left_motor, left_forward * -110);
	pause(50);
	startdrive_time = get_time();
	do {
		enddrive_time = get_time();
	} while (enddrive_time - startdrive_time < drive_time); 
	
	motor_set_vel(right_motor, right_forward * 0);
	motor_set_vel(left_motor, left_forward * 0);
	pause(50);
}

void turn_left_one(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,0);
	motor_set_vel(left_motor, -120);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle < drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void turn_left_two(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,120);
	motor_set_vel(left_motor, 0);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle < drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void turn_right_one(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,-110);
	motor_set_vel(left_motor, 110);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle > drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void drive_straight(int drive_time) {
	int enddrive_time, startdrive_time;
	
	motor_set_vel(right_motor, right_forward * 110);
	motor_set_vel(left_motor, left_forward * 110);
	pause(50);
	startdrive_time = get_time();
	do {
		enddrive_time = get_time();
	} while (enddrive_time - startdrive_time < drive_time); 
	
	motor_set_vel(right_motor, right_forward * 0);
	motor_set_vel(left_motor, left_forward * 0);
	pause(50);
}


/*
//decide whether IRs are seeing light or dark
int left_IR_on() {
	if (analog_read(left_IR) >= 0 && analog_read(left_IR) <600) { //check IR values for each LED white values
	return (1);
	}
	
	else {
	return (0);
	}
}

int mid_IR_on() {
	if (analog_read(left_IR) >= 0 && analog_read(mid_IR) <600) { //check IR values for each LED
	return (1);
	}
	
	else {
	return (0);
	}
}

int right_IR_on() {
	if (analog_read(right_IR) >= 0 && analog_read(right_IR) <600) { //IR values
	return (1);
	}
	
	else {
	return (0);
	}
}



void init_decision() {

	if (Corner=0) {
		if (left_IR_on()==1 && mid_IR_on()==0 && right_IR_on()==0) {
			turn_left(0);
		} else if (left_IR_on()==0 && mid_IR_on()==0 && right_IR_on()==1) {
			turn_left(180);
		} else if (left_IR_on()==0 && mid_IR_on()==1 && right_IR_on()==1) {
			turn_left(90);
		} else if (left_IR_on()==1 && mid_IR_on()==1 && right_IR_on()==0) {
			turn_right(-90);
		} else if (left_IR_on()==1 && mid_IR_on()==1 && right_IR_on()==1) {
			drive_straight(100);
		}
	} else if (Corner=1) {
		if (left_IR_on()==0 && mid_IR_on()==1 && right_IR_on()==1) {
			turn_left(0);
		} else if (left_IR_on()==1 && mid_IR_on()==1 && right_IR_on()==0) {
			turn_left(180);
		} else if (left_IR_on()==1 && mid_IR_on()==0 && right_IR_on()==0) {
			turn_left(90);
		} else if (left_IR_on()==0 && mid_IR_on()==0 && right_IR_on()==1) {
			turn_right(-90);
		} else if (left_IR_on()==0 && mid_IR_on()==0 && right_IR_on()==0) {
			drive_straight(100);
		}
	}
}
	
*/

void init_decision() {

	if (analog_read(22)<(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		drive_straight(10);
	} else if (analog_read(22)<(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		turn_left_two(85);
	} else if (analog_read(22)>(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(600);
		pause(10);
		turn_right_one(-83);
	} else if (analog_read(22)>(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(500);
		pause(10);
		turn_left_two(85);
		pause(10);
		turn_left_two(85);
	}
}

int usetup (void) {
	set_auto_halt(0);
	
	printf_P (PSTR("\nPlace robot,    press go.")); 
	go_click ();
	printf_P (PSTR("\nStabilizing..."));
	pause (500);
	printf_P (PSTR("\nCalibrating     offset...\n"));
	gyro_init (gyro_port, LSB_MS_PER_DEG, 500L);
	go_click ();
/*	do
	{
		printf("\nCorner: %d", Corner=frob_read_range(0,1));
		pause(50);
	} while (!go_press());
	
	go_click();
*/
	return(0);
}

int umain (void) {
	init_decision();
	return 0;
}


