/* AWESOME CODE THAT SCORES A POINT!!! WHOOHOO 1/25/09 12:23AM ZOMG!!! 
*/

#include <joyos.h>
#include <lib/pid.h>
#include <happylib.h>
#include <math.h>

#define right_forward 1
#define left_forward 1
#define right_motor 0
#define left_motor 2
#define right_IR 13
#define mid_IR 14
#define left_IR 15
#define LSB_US_PER_DEG	1330000
#define gyro_port 11
#define right_bumper 0
#define left_bumper 2
#define servo 0
#define RightEncoder 24
#define LeftEncoder 25
#define front_dist_sensor 22
#define left_dist_sensor 20
#define right_dist_sensor 23
#define back_dist_sensor 21

#define TargetVelocity 100
#define MaxVelocity 250

uint8_t team_number[2] = {16,0};

//define turns

void back_up(int drive_time) {
	int enddrive_time, startdrive_time;
	
	motor_set_vel(right_motor, right_forward * -110);
	motor_set_vel(left_motor, left_forward * -110);
	pause(50);
	startdrive_time = get_time();
	do {
		enddrive_time = get_time();
	} while (enddrive_time - startdrive_time < drive_time); 
	
	motor_set_vel(right_motor, right_forward * 0);
	motor_set_vel(left_motor, left_forward * 0);
	pause(50);
}

void turn_left_one(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,90);
	motor_set_vel(left_motor, -130);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle < drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void turn_left_two(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,120);
	motor_set_vel(left_motor, 0);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle < drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void turn_right_one(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,-110);
	motor_set_vel(left_motor, 110);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while (enddrive_angle - startdrive_angle > drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}

void drive_straight(int drive_time) {
	int enddrive_time, startdrive_time;
	
	motor_set_vel(right_motor, right_forward * 110);
	motor_set_vel(left_motor, left_forward * 110);
	pause(50);
	startdrive_time = get_time();
	do {
		enddrive_time = get_time();
	} while (enddrive_time - startdrive_time < drive_time); 
	
	motor_set_vel(right_motor, right_forward * 0);
	motor_set_vel(left_motor, left_forward * 0);
	pause(50);
}




void init_decision() {

	if (analog_read(22)<(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		drive_straight(10);
	} else if (analog_read(22)<(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		turn_left_two(85);
	} else if (analog_read(22)>(300) && analog_read(23)<(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(600);
		pause(10);
		turn_right_one(-83);
	} else if (analog_read(22)>(300) && analog_read(23)>(300)) {
		printf("\nfront=%d right=%d",analog_read(22), analog_read(23));
		back_up(500);
		pause(10);
		turn_left_one(85);
		pause(10);
		turn_left_two(85);
	}
}


//scores a point!! straight, right, pushes ball into goal


void go_forward(float turn_dist) // go forward while back distance sensor is less than 14 inches
{
	do
	{	motor_set_vel(right_motor, 110);
		motor_set_vel(left_motor, 110);
	}
		while (irdist_read(back_dist_sensor)/2.54 < turn_dist);
		
		motor_set_vel(right_motor, 0);
		motor_set_vel(left_motor, 0);
}

//turn right 90 works with skid
void turn_right(float drive_angle) {

	float enddrive_angle, startdrive_angle;
	startdrive_angle = gyro_get_degrees();
	/*printf( "\n%f" , (float) startdrive_angle);
	go_click();*/
	motor_set_vel(right_motor,-110);
	motor_set_vel(left_motor, 110);
	pause(50);
	
	do {
		enddrive_angle = gyro_get_degrees();
		pause(10);
		//printf("\n%f", (float) enddrive_angle);
	} while ((enddrive_angle - startdrive_angle) > drive_angle); 
	
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
}


float rightwalldist() {
	
	return fabs(irdist_read(right_dist_sensor) * cos(-gyro_get_degrees()-90.0));
}

void follow_wall(uint32_t stoptime)
{	while (get_time() < stoptime) {
		if 	(rightwalldist() >= 19.5*2.54 && rightwalldist() <= 20.5*2.54 )
		{	motor_set_vel(right_motor, -110);
			motor_set_vel(left_motor, -110);
		}
		else if (rightwalldist() < 19.4*2.54)
		{	motor_set_vel(right_motor, -115);
			motor_set_vel(left_motor, -110);
		}
		else if (rightwalldist() > 20.6*2.54)
		{	motor_set_vel(right_motor, -110);
			motor_set_vel(left_motor, -115);
		}
		else if (rightwalldist() < 16*2.54)
		{	break;
		}
	}
	motor_set_vel(right_motor, 0);
	motor_set_vel(left_motor, 0);
	return;
}
		
	
		
int usetup (void) {
	set_auto_halt(0);
	printf_P (PSTR("\nPlace robot,    press go."));
	go_click ();
	printf_P (PSTR("\nStabilizing..."));
	//pause (500);
	printf_P (PSTR("\nCalibrating     offset...\n"));
	gyro_init (gyro_port, LSB_US_PER_DEG, 500L);
	irdist_set_calibration(12452, 0);
	return 0;
}

int	umain (void) 
{
	init_decision();
	gyro_set_degrees(0);

/*while (1) {
		printf("\n%f, %f", (double) rightwalldist(), (double) gyro_get_degrees());
	}*/
	go_forward(15.0);
	pause(50);
	turn_left_one(85.0);
	pause(50);
	follow_wall(get_time() + 6000);
	pause(50);
	/*turn_right(-90.0);
	pause(50);*/
	return 0;
}

